classification
Title: Python does not cross compile properly
Type: compile error Stage: resolved
Components: Build, Cross-Build Versions: Python 3.4
process
Status: closed Resolution: rejected
Dependencies: Superseder:
Assigned To: Nosy List: Lothsahn, doko, eric.araujo, jcea
Priority: normal Keywords:

Created on 2012-11-21 21:58 by Lothsahn, last changed 2013-02-06 13:29 by doko. This issue is now closed.

Messages (4)
msg176080 - (view) Author: Lothsahn (Lothsahn) Date: 2012-11-21 21:58
Python doesn't really support cross compilation.  I've created a patch for Python 2.7.3 which compiles nearly all of Python (except a couple modules).  Patches for Python 3 are also included, but I didn't have anything to do with them.

My patch allows for cross compilation as well as the building of modules.

The only issue I'm aware of is that the ELFCLASS of the modules that are to be built must be the same.  This is because python uses sys.platform to determine which folder to generate the modules in, and so the sys.platform is always that of the host system.  When generating the modules, we should probably generate them twice, once for the host system (using sys.platform), and once for the cross-compiled system (using the cross-compiled system's sys.platform).

The patches can be found here:
http://randomsplat.com/id5-cross-compiling-python-for-embedded-linux.html

Given the rise of embedded systems, it's a big drawback that cross compiling Python is so difficult.
msg176087 - (view) Author: Jesús Cea Avión (jcea) * (Python committer) Date: 2012-11-22 01:19
This is 3.4 material.

Could you possibly work with us to properly integrate in 3.4?.
msg176188 - (view) Author: Éric Araujo (eric.araujo) * (Python committer) Date: 2012-11-23 17:14
See also:

http://bugs.python.org/issue3754
  cross-compilation support for python build

http://bugs.python.org/issue1006238
  cross compile patch

http://bugs.python.org/issue1597850
  Cross compiling patches for MINGW (superseder of http://bugs.python.org/issue1339673, cross compile and mingw support)

http://bugs.python.org/issue3871
  cross and native build of python for mingw32 with distutils

http://bugs.python.org/issue3718
  environment variable MACHDEP and python build system

http://bugs.python.org/issue10782
  Not possible to cross-compile due to poor detection of %lld support in printf
msg181521 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2013-02-06 13:29
now closing/rejecting this issue. See
http://mail.python.org/pipermail/python-dev/2013-January/123774.html
for the discussion.
History
Date User Action Args
2013-02-06 13:29:58dokosetstatus: open -> closed
resolution: rejected
stage: resolved
2013-02-06 13:29:26dokosetnosy: + doko
messages: + msg181521
2012-11-23 17:14:24eric.araujosetnosy: + eric.araujo
messages: + msg176188
2012-11-22 01:19:23jceasetnosy: + jcea

messages: + msg176087
versions: + Python 3.4, - Python 3.1, Python 2.7, Python 3.2
2012-11-21 21:58:03Lothsahncreate